package java.awt;

import java.awt.peer.ComponentPeer;

public class DefaultFocusTraversalPolicy extends ContainerOrderFocusTraversalPolicy
{
    private static final long serialVersionUID = 8876966522510157497L;
    
    public DefaultFocusTraversalPolicy() {
    }
    
    @Override
    protected boolean accept(Component component) {
        if (!component.isVisible() || !component.isDisplayable() || !component.isEnabled()) {
            return false;
        }
        if (!(component instanceof Window)) {
            Container container = component.getParent();
            while (container != null) {
                if (!container.isEnabled() && !container.isLightweight()) {
                    return false;
                }
                if ((container instanceof Window)) {
                    break;
                }
                container = container.getParent();
            }
        }
        int focusable = component.isFocusable();
        if (component.isFocusTraversableOverridden()) {
            return focusable;
        }
        ComponentPeer peer = component.getPeer();
        return peer != null && peer.isFocusable();
    }
}
